#!/usr/local/bin/ruby

require 'xml'

def traverse(node, level)
  puts "#{node.inspect}\n[#{node.name}, #{node.node_type}]".gsub(/^/, "  "*level)
  puts "#{node.to_s}".gsub(/^/, "  "*level) if node.node_type == XML::XMLNode::TEXT_NODE
  node.each_child { |child| traverse(child, level+1) }
end

src = []
ARGV.each do
  |arg|
  case arg
  when /--noblank/
    XML.no_blanks
  when /--noentity/
    XML.no_entities
  else
    src << arg
  end
end

src.each do
  |s|
  traverse(XML.parse_file(s).get_root, 0)
end
